Attribute VB_Name = "ModChess"
Option Explicit

Public Const colBoardMain = 14
Public Const rowBoardMain = 9

Public Const countRank As Byte = 8
Public Const countFile As Byte = 8

Public Const ascRank0 As Byte = 48
Public Const ascRank1 As Byte = 49
Public Const ascFileA As Byte = 97
Public Const ascFileH As Byte = 104

Public Const a8 As Byte = &HB4, b8 As Byte = &HB5, c8 As Byte = &HB6, d8 As Byte = &HB7
Public Const a7 As Byte = &HA4, b7 As Byte = &HA5, c7 As Byte = &HA6, d7 As Byte = &HA7
Public Const a6 As Byte = &H94, b6 As Byte = &H95, c6 As Byte = &H96, d6 As Byte = &H97
Public Const a5 As Byte = &H84, b5 As Byte = &H85, c5 As Byte = &H86, d5 As Byte = &H87
Public Const a4 As Byte = &H74, b4 As Byte = &H75, c4 As Byte = &H76, d4 As Byte = &H77
Public Const a3 As Byte = &H64, b3 As Byte = &H65, c3 As Byte = &H66, d3 As Byte = &H67
Public Const a2 As Byte = &H54, b2 As Byte = &H55, c2 As Byte = &H56, d2 As Byte = &H57
Public Const a1 As Byte = &H44, b1 As Byte = &H45, c1 As Byte = &H46, d1 As Byte = &H47

Public Const e8 As Byte = &HB8, f8 As Byte = &HB9, g8 As Byte = &HBA, h8 As Byte = &HBB
Public Const e7 As Byte = &HA8, f7 As Byte = &HA9, g7 As Byte = &HAA, h7 As Byte = &HAB
Public Const e6 As Byte = &H98, f6 As Byte = &H99, g6 As Byte = &H9A, h6 As Byte = &H9B
Public Const e5 As Byte = &H88, f5 As Byte = &H89, g5 As Byte = &H8A, h5 As Byte = &H8B
Public Const e4 As Byte = &H78, f4 As Byte = &H79, g4 As Byte = &H7A, h4 As Byte = &H7B
Public Const e3 As Byte = &H68, f3 As Byte = &H69, g3 As Byte = &H6A, h3 As Byte = &H6B
Public Const e2 As Byte = &H58, f2 As Byte = &H59, g2 As Byte = &H5A, h2 As Byte = &H5B
Public Const e1 As Byte = &H48, f1 As Byte = &H49, g1 As Byte = &H4A, h1 As Byte = &H4B

Public Const fileA As Byte = &H4, fileB As Byte = &H5, fileC As Byte = &H6
Public Const fileD As Byte = &H7, fileE As Byte = &H8, fileF As Byte = &H9
Public Const fileG As Byte = &HA, fileH As Byte = &HB

Public Const rank1 As Byte = &H4, rank2 As Byte = &H5, rank3 As Byte = &H6
Public Const rank4 As Byte = &H7, rank5 As Byte = &H8, rank6 As Byte = &H9
Public Const rank7 As Byte = &HA, rank8 As Byte = &HB

Public Const pawnWhiteAttackRightOffset = 17
Public Const pawnWhiteAttackLeftOffset = 15
Public Const pawnBlackAttackRightOffset = -15
Public Const pawnBlackAttackLeftOffset = -17

Public Const typeKing As Byte = 1
Public Const typeQueen As Byte = typeKing + 1
Public Const typeRook As Byte = typeQueen + 1
Public Const typeBishop As Byte = typeRook + 1
Public Const typeKnight As Byte = typeBishop + 1
Public Const typePawn As Byte = typeKnight + 1

Public Const valuePawn = 100
Public Const valueKnight = 300
Public Const valueBishop = 325
Public Const valueRook = 500
Public Const valueQueen = 975
Public Const valueKing = 1000

Public Const moveTypeNull As Byte = 0
Public Const moveStandard As Byte = moveTypeNull + 1
Public Const movePromotionQueen As Byte = moveStandard + 1
Public Const movePromotionRook As Byte = movePromotionQueen + 1
Public Const movePromotionBishop As Byte = movePromotionRook + 1
Public Const movePromotionKnight As Byte = movePromotionBishop + 1
Public Const moveEnPassant As Byte = movePromotionKnight + 1
Public Const moveCastleQueenSide As Byte = moveEnPassant + 1
Public Const moveCastleKingSide As Byte = moveCastleQueenSide + 1

Public Const statusNormal As Byte = 1
Public Const statusInCheck As Byte = statusNormal + 1
Public Const statusDrawStaleMate As Byte = statusInCheck + 1
Public Const statusInCheckMate As Byte = statusDrawStaleMate + 1

Const colorFillRed = 3
Const colorFillGreen = 10
Public Const colorFillBlue = 34
Const colorFillLightGreen = 35
Public Const colorFillYellow = 36
Const colorFillPaleBlue = 37
Const colorFillPink = 38
Const colorFillPurple = 39
Public Const colorFillBeige = 40
Const colorFillAqua = 42
Const colorFillLime = 43
Const colorFillGold = 44
Public Const colorFillGray = 48
Public Const colorFillSeaGreen = 50
Public Const colorFillStripped = xlNone
Const colorFillOrange = 45

Const WhiteSquare = " "
Const BlackSquare = "+"

Const BlackPawnW = "o"
Const BlackPawnB = "O"
Const BlackkNightW = "m"
Const BlackkNightB = "M"
Const BlackBishopW = "v"
Const BlackBishopB = "V"
Const BlackRookW = "t"
Const BlackRookB = "T"
Const BlackQueenW = "w"
Const BlackQueenB = "W"
Const BlackKingW = "l"
Const BlackKingB = "L"

Const BlackPieceSymbol = BlackKingB + BlackQueenB + BlackRookB + _
                         BlackBishopB + BlackkNightB + BlackPawnB

Public Const strAbbreviationPiecesEn = "KQRBNP"
Public Const strAbbreviationPiecesFr = "RDTFCP"

Public boardMain As Board
Public isFrench As Boolean
Public colorSquareBlack As Integer
Public isColorSquareBlackChanged As Boolean

Public Const offsetDiffOrdinal As Integer = h8 - a1
Const maxDiffOrdinal = 1 + offsetDiffOrdinal * 2
Public offsetKingAttacking(maxDiffOrdinal) As Integer
Public offsetQueenAttacking(maxDiffOrdinal) As Integer
Public offsetRookAttacking(maxDiffOrdinal) As Integer
Public offsetBishopAttacking(maxDiffOrdinal) As Integer
Public isKnightAttacking(maxDiffOrdinal) As Boolean
Public isWhitePawnAttacking(maxDiffOrdinal) As Boolean
Public isBlackPawnAttacking(maxDiffOrdinal) As Boolean

Public Const nbrOffsetKnight As Byte = 8
Public offsetKnight(nbrOffsetKnight) As Integer

Public Const nbrOffsetBishop As Byte = 4
Public offsetBishop(nbrOffsetBishop) As Integer

Public Const nbrOffsetRook As Byte = 4
Public offsetRook(nbrOffsetRook) As Integer

Public Const nbrOffsetQueen As Byte = 8
Public offsetQueen(nbrOffsetQueen) As Integer

Public Const nbrOffsetKing As Byte = 8
Public offsetKing(nbrOffsetKing) As Integer

Public listOfMoves As Collection
Public movePlayer As Move

Function FileFromOrdinal(ByVal ordSqr As Byte) As Byte
    FileFromOrdinal = ordSqr And &HF
End Function

Function RankFromOrdinal(ByVal ordSqr As Byte) As Byte
    RankFromOrdinal = ordSqr \ 16
End Function

Public Function FileFromName(ByVal strNameFile As String) As Byte
Dim indFile As Byte

    indFile = Asc(strNameFile) - ascFileA + fileA
    If indFile < fileA Or indFile > fileH Then
        FileFromName = 0
    Else
        FileFromName = indFile
    End If
End Function

Public Function RankFromName(ByVal strNameRank As String) As Byte
Dim indRank As Byte

    indRank = Asc(strNameRank) - ascRank1 + rank1
    If indRank < rank1 Or indRank > rank8 Then
        RankFromName = 0
    Else
        RankFromName = indRank
    End If
End Function

Function FileToString(ByVal indFile As Byte) As String
    FileToString = Chr(ascFileA + indFile - fileA)
End Function

Function RankToString(ByVal indRank As Byte) As String
    RankToString = Chr(ascRank1 + indRank - rank1)
End Function

Function OrdinalFromFileRank(ByVal indFile As Byte, ByVal indRank As Byte) As Byte
    OrdinalFromFileRank = indRank * 16 Or indFile
End Function

Function NamePiece(ByVal typeOfPiece As Byte) As String
    If typeOfPiece >= typeKing And typeOfPiece <= typePawn Then
        NamePiece = Mid(strAbbreviationPiecesEn, typeOfPiece, 1)
    Else
        ErrWarn 3200
    End If
End Function

Function AbbrToTypePiece(ByVal strPiece As String, ByRef typeOfPiece As Byte) As Boolean
    typeOfPiece = InStr(strAbbreviationPiecesEn, strPiece)
    AbbrToTypePiece = typeOfPiece > 0
End Function

Public Sub InitAttackingTable()
Dim varOffset As Variant, offsetDir As Variant
Dim indSliding As Integer, indOffset As Integer
        
    colorSquareBlack = colorFillBeige
    If isWhitePawnAttacking(offsetDiffOrdinal + pawnWhiteAttackRightOffset) Then
        Exit Sub
    End If
    indOffset = 0: varOffset = Array(1, -1, 15, -15, 16, -16, 17, -17)
    For Each offsetDir In varOffset
        indOffset = indOffset + 1
        offsetKing(indOffset) = offsetDir
        offsetKingAttacking(offsetDiffOrdinal + offsetDir) = True
    Next
    indOffset = 0: varOffset = Array(1, -1, 16, -16)
    For Each offsetDir In varOffset
        indOffset = indOffset + 1
        offsetQueen(indOffset) = offsetDir
        offsetRook(indOffset) = offsetDir
        For indSliding = 1 To countRank - 1
            offsetQueenAttacking(offsetDiffOrdinal + offsetDir * indSliding) = CInt(offsetDir)
            offsetRookAttacking(offsetDiffOrdinal + offsetDir * indSliding) = CInt(offsetDir)
        Next
    Next
    indOffset = 0: varOffset = Array(15, -15, 17, -17)
    For Each offsetDir In varOffset
        indOffset = indOffset + 1
        offsetQueen(indOffset + nbrOffsetRook) = offsetDir
        offsetBishop(indOffset) = offsetDir
        For indSliding = 1 To countRank - 1
            offsetQueenAttacking(offsetDiffOrdinal + offsetDir * indSliding) = CInt(offsetDir)
            offsetBishopAttacking(offsetDiffOrdinal + offsetDir * indSliding) = CInt(offsetDir)
        Next
    Next
    indOffset = 0: varOffset = Array(14, -14, 18, -18, 31, -31, 33, -33)
    For Each offsetDir In varOffset
        indOffset = indOffset + 1
        offsetKnight(indOffset) = offsetDir
        isKnightAttacking(offsetDiffOrdinal + offsetDir) = True
    Next
    isWhitePawnAttacking(offsetDiffOrdinal + pawnWhiteAttackRightOffset) = True
    isWhitePawnAttacking(offsetDiffOrdinal + pawnWhiteAttackLeftOffset) = True
    isBlackPawnAttacking(offsetDiffOrdinal + pawnBlackAttackRightOffset) = True
    isBlackPawnAttacking(offsetDiffOrdinal + pawnBlackAttackLeftOffset) = True
End Sub

Private Function IsMatchedPiece(ByVal typePieceThis As Byte, pieceList As Collection) As Boolean
Dim indPiece As Byte, pieceThis As Piece

    For indPiece = 1 To pieceList.Count
        Set pieceThis = pieceList(indPiece)
        If pieceThis.TypePiece = typePieceThis Then
            pieceList.Remove indPiece
            IsMatchedPiece = True
            Exit Function
        End If
    Next
    IsMatchedPiece = False
End Function

Private Sub CollCopy(ByVal nbrObj As Integer, listSource As Collection, listDestination As Collection)
Dim objItem As Object, indObj As Integer

    For indObj = 1 To nbrObj
        Set objItem = listSource(indObj)
        listDestination.Add objItem, objItem.Key
    Next
End Sub

Private Sub CollIntersect(captureListWhiteRef As Collection, captureListBlackRef As Collection, listPieceIntersect As Collection)
Dim indCaptureWhite As Integer, captureWhite As Piece, nbrCaptureWhite As Byte, captureListWhite As New Collection
Dim indCaptureBlack As Integer, captureBlack As Piece, nbrCaptureBlack As Byte, captureListBlack As New Collection

    nbrCaptureBlack = captureListBlackRef.Count
    CollCopy nbrCaptureBlack, captureListBlackRef, captureListBlack
    nbrCaptureWhite = captureListWhiteRef.Count
    If nbrCaptureWhite > 0 Then
        CollCopy nbrCaptureWhite, captureListWhiteRef, captureListWhite
        For indCaptureWhite = nbrCaptureWhite To 1 Step -1
            Set captureWhite = captureListWhite(indCaptureWhite)
            If IsMatchedPiece(captureWhite.TypePiece, captureListBlack) Then
                captureListWhite.Remove indCaptureWhite
            Else
                listPieceIntersect.Add captureWhite, captureWhite.Key
            End If
        Next
    End If
    nbrCaptureBlack = captureListBlack.Count
    If nbrCaptureBlack > 0 Then
        For indCaptureBlack = nbrCaptureBlack To 1 Step -1
            Set captureBlack = captureListBlack(indCaptureBlack)
            If IsMatchedPiece(captureBlack.TypePiece, captureListWhite) Then
                captureListBlack.Remove indCaptureBlack
            Else
                listPieceIntersect.Add captureBlack, captureBlack.Key
            End If
        Next
    End If
End Sub

Sub CollSort(ByRef colObj As Collection)
    CollSorting 1, colObj.Count, colObj
End Sub

Private Sub CollSorting(ByVal indLower As Integer, ByVal indUpper As Integer, _
                ByRef colObj As Collection)
Dim indSplit As Integer

    If indLower < indUpper Then
        indSplit = CollPartition(indLower, indUpper, colObj)
        CollSorting indLower, indSplit - 1, colObj
        CollSorting indSplit + 1, indUpper, colObj
    End If
End Sub

Private Function CollObjEval(ByVal objItem As Object) As Integer

    If TypeOf objItem Is Piece Then
        CollObjEval = objItem.ValuePiece + fileH - objItem.Square.File
        
    ElseIf TypeOf objItem Is Move Then
        CollObjEval = objItem.Score
    Else
        ErrWarn 3400
    End If
End Function

Private Function CollPartition(ByVal indLower As Integer, ByVal indUpper As Integer, _
                            ByRef colObj As Collection) As Integer
Dim indLeft As Integer, indRight As Integer
Dim valuePivot As Integer

    indLeft = indLower + 1
    valuePivot = CollObjEval(colObj(indLower))
    indRight = indUpper
    
    While indLeft <= indRight
        Do While indLeft <= indRight
            If CollObjEval(colObj(indLeft)) >= valuePivot Then
                indLeft = indLeft + 1
            Else
                Exit Do
            End If
        Loop
        Do While indLeft <= indRight
            If CollObjEval(colObj(indRight)) < valuePivot Then
                indRight = indRight - 1
            Else
                Exit Do
            End If
        Loop
        If indLeft < indRight Then
            CollSwap indLeft, indRight, colObj
            indLeft = indLeft + 1
            indRight = indRight - 1
        End If
    Wend
    CollSwap indLower, indRight, colObj
    CollPartition = indRight
End Function

Sub CollSwap(ByVal indLower As Integer, ByVal indUpper As Integer, _
                ByRef colObj As Collection)
Dim objLower As Object, objUpper As Object, indSwap As Integer

    If indLower <> indUpper Then
        If indLower > indUpper Then
            indSwap = indLower
            indLower = indUpper
            indUpper = indSwap
        End If
        Set objLower = colObj(indLower)
        Set objUpper = colObj(indUpper)
        colObj.Remove indLower
        indUpper = indUpper - 1
        colObj.Remove indUpper
        indLower = indLower - 1
        If indLower = 0 Then
            If colObj.Count = 0 Then
                colObj.Add objUpper, objUpper.Key
            Else
                colObj.Add objUpper, objUpper.Key, 1
            End If
        Else
            colObj.Add objUpper, objUpper.Key, , indLower
        End If
        colObj.Add objLower, objLower.Key, , indUpper
    End If
End Sub

Sub DbgMovesNotation(ByVal listMove As Collection)
Dim indMove As Integer, moveThis As Move
    
    If Not listMove Is Nothing Then
        For indMove = 1 To listMove.Count
            Set moveThis = listMove(indMove)
            If moveThis.TypeOfMove <> moveTypeNull Then
                moveThis.PgnSanFormat True
            End If
        Next
        Debug.Print listMove.Count & " moves have been annotated"
    End If
End Sub

Sub DgbMovesPrint(ByVal listMove As Collection)
Const nbrMaxMoveInLine = 10
Dim indMove As Integer, moveThis As Move, strLine As String, nbrMoveInLine As Integer

    If Not listMove Is Nothing Then
        nbrMoveInLine = 0
        strLine = CStr(listMove.Count) + " : "
        For indMove = 1 To listMove.Count
            Set moveThis = listMove(indMove)
            If moveThis.TypeOfMove <> moveTypeNull Then
                If indMove > 1 Then
                    strLine = strLine + ", "
                    If nbrMoveInLine >= nbrMaxMoveInLine Then
                        strLine = strLine + vbCrLf
                        nbrMoveInLine = 0
                    End If
                End If
                strLine = strLine & moveThis.Description & "=" & moveThis.Score
                nbrMoveInLine = nbrMoveInLine + 1
            End If
        Next
        Debug.Print strLine
    End If
End Sub

Sub DgbPiecesPrint(ByVal ListPiece As Collection)
Dim indPiece As Integer, pieceThis As Piece

    For indPiece = 1 To ListPiece.Count
        Set pieceThis = ListPiece(indPiece)
        Debug.Print "Piece" + Str(indPiece) + ": " + pieceThis.Name + pieceThis.Square.Name
    Next
End Sub

Sub ClipboardCopy(ByVal strMsg As String)
Dim dataObj As DataObject

    If Len(strMsg) = 0 Then ErrWarn 3500
    Set dataObj = New DataObject
    dataObj.SetText strMsg
    dataObj.PutInClipboard
    Set dataObj = Nothing

End Sub

Sub ErrWarn(ByVal indCode As Integer)
Dim strMsg As String

    strMsg = "Warning " + CStr(indCode)
    MsgBox strMsg, vbExclamation, "Chess warning "
    
End Sub

Sub GuiPiecePinnedHide()

End Sub

Sub GuiDisplayBoardAt(ByVal isSideWhite As Boolean, ByVal indRow As Integer, _
                        ByVal indCol As Integer, chessBoard As Board)
Dim indRank As Byte, indFile As Byte, cellSqr As Range
Dim strSquare As String
Dim sqr As Square, pieceThis As Piece, isSqrWhite As Boolean, indEdge As Byte

    For indRank = 0 To 7
        If isSideWhite Then
            Cells(indRow + 1, indRank + indCol) = Chr(ascFileA + indRank)
            Cells(indRow - indRank, indCol - 1) = indRank + 1
        Else
            Cells(indRow + 1, indRank + indCol) = Chr(ascFileH - indRank)
            Cells(indRow + indRank - 7, indCol - 1) = indRank + 1
        End If
        For indFile = 0 To 7
            Set cellSqr = IIf(isSideWhite, Cells(indRow - indRank, indCol + indFile), _
                Cells(indRow + indRank - 7, indCol - indFile + 7))
            isSqrWhite = (indFile And 1) Xor (indRank And 1)
            If chessBoard Is Nothing Then
                strSquare = IIf(colorSquareBlack = colorFillStripped And Not isSqrWhite, BlackSquare, WhiteSquare)
                cellSqr.Select
                GuiPiecePinnedHide
                Selection.Interior.ColorIndex = IIf(isSqrWhite, xlNone, colorSquareBlack)
            ElseIf isColorSquareBlackChanged Then
                strSquare = IIf(colorSquareBlack = colorFillStripped And Not isSqrWhite, BlackSquare, WhiteSquare)
                If Not isSqrWhite Then
                    cellSqr.Select
                    Selection.Interior.ColorIndex = colorSquareBlack
                End If
            End If
            If Not chessBoard Is Nothing Then
                Set sqr = chessBoard.GetSquareFileRank(indFile + fileA, indRank + rank1)
                Set pieceThis = sqr.PieceOnSquare
                If pieceThis Is Nothing Then
                    strSquare = IIf(colorSquareBlack = colorFillStripped And Not sqr.IsWhite, BlackSquare, WhiteSquare)
                Else
                    strSquare = Mid(IIf(pieceThis.IsWhite, strAbbreviationPiecesEn, BlackPieceSymbol), pieceThis.TypePiece, 1)
                    If colorSquareBlack <> colorFillStripped Or sqr.IsWhite Then
                        strSquare = LCase(strSquare)
                    End If
                End If
            End If
            cellSqr.Value = strSquare
        Next
    Next
End Sub

Sub DynamicContext()
    InitAttackingTable
    If Not boardMain Is Nothing Then
        boardMain.FreeBoard
    End If
    Set boardMain = New Board
    
    ClearListMove listOfMoves
    Set listOfMoves = New Collection
End Sub

Function EvalMove(ByVal moveThis As Move) As Integer
Const valNoLegal = -10000, valMat = 1000, valCheck = 5
Dim valeurPiecesJoueur As Integer, valeurPiecesAdversaire As Integer
Dim joueur As Player, adversaire As Player, Score As Integer, delta As Integer
Dim controleCentreJoueur As Integer, controleCentreAdversaire As Integer
    
    If moveThis.IsInCheck Then  ' Le coup n'a pas rsolu l'chec. Le coup est illgal
        Score = valNoLegal: Exit Function
    End If
    
    If boardMain.MakeAMove_Internal(moveThis) Then ' Simule le coup  valuer
        EvalMove = valMat: Exit Function  ' Le Roi adverse est Echec et Mat !
    End If
    
    Score = 0
    If moveThis.IsEnemyInCheck Then
        Score = Score + valCheck   ' Echec au Roi
    End If
    
    Set joueur = moveThis.PieceMoved.Player
    Set adversaire = joueur.OtherPlayer
    
    valeurPiecesJoueur = joueur.SumValuePiece()
    valeurPiecesAdversaire = adversaire.SumValuePiece()
    delta = valeurPiecesJoueur - valeurPiecesAdversaire ' Material
    Score = Score + delta
    
    delta = EvalDegreeFreedom(joueur, adversaire)
    Score = Score + delta
  
'    controleCentreJoueur = CtrlCenter(joueur)
'    controleCentreAdversaire = CtrlCenter(adversaire) ' Contrle du centre
'    delta = controleCentreJoueur - controleCentreAdversaire
'    Score = Score + delta
    
    boardMain.UndoMove_Internal ' Annule le coup simul pour son valuation
    EvalMove = Score
End Function

Function EvalDegreeFreedom(joueur As Player, adversaire As Player) As Integer
Const coeffBlockedPawn = 4
Dim listeCoupsJoueur As Collection, listeCoupsAdversaire As Collection
Dim nbrCoupJoueur As Integer, nbrCoupAdversaire As Integer
Dim distanceRoqueJoueur As Integer, distanceRoqueAdversaire As Integer
Dim nbrMoveBlockPawnJoueur As Integer, nbrMoveBlockPawnAdversaire As Integer
Dim Score As Integer, delta As Integer

    Set listeCoupsJoueur = New Collection
    joueur.GenAllLazyMoves listeCoupsJoueur
    nbrCoupJoueur = listeCoupsJoueur.Count
    distanceRoqueJoueur = DistanceToCastle(joueur, listeCoupsJoueur)
    nbrMoveBlockPawnJoueur = BishopAboveCentralPawn(listeCoupsJoueur)
    ClearListMove listeCoupsJoueur
    
    Set listeCoupsAdversaire = New Collection
    adversaire.GenAllLazyMoves listeCoupsAdversaire
    nbrCoupAdversaire = listeCoupsAdversaire.Count
    distanceRoqueAdversaire = DistanceToCastle(adversaire, listeCoupsAdversaire)
    nbrMoveBlockPawnAdversaire = BishopAboveCentralPawn(listeCoupsAdversaire)
    ClearListMove listeCoupsAdversaire
    
    delta = nbrCoupJoueur - nbrCoupAdversaire ' Degr de libert
    Score = delta
    
'    delta = distanceRoqueJoueur - distanceRoqueAdversaire
'    Score = Score + delta
'
'    delta = nbrMoveBlockPawnAdversaire - nbrMoveBlockPawnJoueur
'    Score = Score + coeffBlockedPawn * delta
    
    EvalDegreeFreedom = Score
End Function

Sub ClearListMove(ByRef listMove As Collection)
Dim moveThis As Move

    If Not listMove Is Nothing Then
        While listMove.Count > 0
            Set moveThis = listMove(1)
            listMove.Remove 1
            Set moveThis = Nothing
        Wend
        Set listMove = Nothing
    End If
End Sub

Function CtrlCenter(playerThis As Player) As Integer
Const coeffAdverse = 3
Dim nbrSqrCtrlPlayer As Integer, nbrSqrCtrlOpponent As Integer

    nbrSqrCtrlPlayer = 0: nbrSqrCtrlOpponent = 0
    If playerThis.IsWhite Then
        If playerThis.CanAttack(d5) Then nbrSqrCtrlOpponent = nbrSqrCtrlOpponent + 1
        If playerThis.CanAttack(e5) Then nbrSqrCtrlOpponent = nbrSqrCtrlOpponent + 1
        If playerThis.CanAttack(d4) Then nbrSqrCtrlPlayer = nbrSqrCtrlPlayer + 1
        If playerThis.CanAttack(e4) Then nbrSqrCtrlPlayer = nbrSqrCtrlPlayer + 1
    Else
        If playerThis.CanAttack(d4) Then nbrSqrCtrlOpponent = nbrSqrCtrlOpponent + 1
        If playerThis.CanAttack(e4) Then nbrSqrCtrlOpponent = nbrSqrCtrlOpponent + 1
        If playerThis.CanAttack(d5) Then nbrSqrCtrlPlayer = nbrSqrCtrlPlayer + 1
        If playerThis.CanAttack(e5) Then nbrSqrCtrlPlayer = nbrSqrCtrlPlayer + 1
    End If
    CtrlCenter = nbrSqrCtrlPlayer + coeffAdverse * nbrSqrCtrlOpponent
End Function

Function DistanceToCastle(playerThis As Player, listOfMove As Collection) As Integer
Const noBishop = 1, noKnight = 1, bishopCanMove = 1
Dim Score As Integer

    Score = 0
    If playerThis.PieceKing.HasMoved Then Exit Function
    If playerThis.IsWhite Then
        If boardMain.GetSquare(f1).IsEmpty Then
            Score = noBishop
        ElseIf CanBishopMove(f1, listOfMove) Then
            Score = bishopCanMove
        End If
        If boardMain.GetSquare(g1).IsEmpty Then
            Score = Score + noKnight
        End If
    Else
        If boardMain.GetSquare(f8).IsEmpty Then
            Score = noBishop
        ElseIf CanBishopMove(f8, listOfMove) Then
            Score = bishopCanMove
        End If
        If boardMain.GetSquare(g8).IsEmpty Then
            Score = Score + noKnight
        End If
    End If
    DistanceToCastle = Score
End Function

Function CanBishopMove(ByVal Ordinal As Integer, listOfMove As Collection) As Boolean
Dim moveThis As Move

    For Each moveThis In listOfMove
        If moveThis.PieceMoved.TypePiece = typeBishop Then
            If moveThis.SquareFrom.Ordinal = Ordinal Then
                CanBishopMove = True: Exit Function
            End If
        End If
    Next
    CanBishopMove = False
End Function

Function BishopAboveCentralPawn(listOfMove As Collection) As Integer
Dim moveThis As Move, Ordinal As Integer, fileBishop As Integer, rankBishop As Integer
Dim nbrMoveBlockPawn As Integer, rankPawn As Integer, piecePawn As Piece

    nbrMoveBlockPawn = 0
    For Each moveThis In listOfMove
        If moveThis.PieceMoved.TypePiece = typeBishop Then
            Ordinal = moveThis.SquareTo.Ordinal
            fileBishop = FileFromOrdinal(Ordinal)
            rankBishop = RankFromOrdinal(Ordinal)
            If fileBishop = fileD Or fileBishop = fileE Then
                If moveThis.PieceMoved.IsWhite Then
                    rankPawn = rankBishop - 1
                Else
                    rankPawn = rankBishop + 1
                End If
                Set piecePawn = boardMain.GetPawn(OrdinalFromFileRank(fileBishop, rankPawn))
                If Not piecePawn Is Nothing Then
                    If Not piecePawn.HasMoved Then
                        nbrMoveBlockPawn = nbrMoveBlockPawn + 1
                    End If
                End If
            End If
        End If
    Next
    BishopAboveCentralPawn = nbrMoveBlockPawn
End Function

Sub DbgBestMove()
    ClearListMove listOfMoves
    Set listOfMoves = New Collection
    boardMain.PlayerWhite.GenAllLazyMoves listOfMoves
    For Each movePlayer In listOfMoves
        movePlayer.Score = EvalMove(movePlayer)
    Next
    CollSort listOfMoves
    DgbMovesPrint listOfMoves
End Sub
