VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
END
Attribute VB_Name = "Square"
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit
Private m_isWhite As Boolean
Private m_fileSqr As Byte
Private m_rankSqr As Byte
Private m_ordinal As Byte
Private m_piece As Piece

Private Sub Class_Initialize()
    m_isWhite = True
    m_ordinal = 0
    m_fileSqr = 0
    m_rankSqr = 0
    Set m_piece = Nothing
End Sub

Public Property Let Ordinal(ByVal ordOfSqr As Byte)
    m_ordinal = ordOfSqr
    m_fileSqr = FileFromOrdinal(ordOfSqr)
    m_rankSqr = RankFromOrdinal(ordOfSqr)
    
    m_isWhite = CBool(m_rankSqr And 1)
    If m_fileSqr And 1 Then
        m_isWhite = Not m_isWhite
    End If
End Property

Public Property Get Ordinal() As Byte
    Ordinal = m_ordinal
End Property

Public Property Get File() As Byte
    File = m_fileSqr
End Property

Public Property Get Filename() As String
    Filename = Chr(ascFileA + m_fileSqr - fileA)
End Property

Public Property Get Rank() As Byte
    Rank = m_rankSqr
End Property

Public Property Get RankName() As String
    RankName = CStr(m_rankSqr + 1 - rank1)
End Property

Public Property Get Name() As String
    Name = Filename + RankName
End Property

Public Property Get IsWhite() As Integer
    IsWhite = m_isWhite
End Property

Public Property Get PieceOnSquare() As Piece
    Set PieceOnSquare = m_piece
End Property

Public Property Get Value() As Integer
    If m_piece Is Nothing Then
        Value = 0
    Else
        Value = m_piece.ValuePiece
    End If
End Property

Public Sub SetPieceSquare(thisPiece As Piece)
    Set m_piece = thisPiece
End Sub

Public Function IsEmpty() As Boolean
    IsEmpty = m_piece Is Nothing
End Function

Public Function IsSameLine(ByVal sqrThis As Square) As Boolean
    If m_rankSqr = sqrThis.Rank Then
        IsSameLine = True
    ElseIf m_fileSqr = sqrThis.File Then
        IsSameLine = True
    Else
        IsSameLine = False
    End If
End Function

Public Function IsAlignedVertically(ByVal sqrThis As Square) As Boolean
    IsAlignedVertically = m_rankSqr = sqrThis.Rank
End Function

Public Function IsAlignedHorizontally(ByVal sqrThis As Square) As Boolean
    IsAlignedHorizontally = m_fileSqr = sqrThis.File
End Function

Public Function IsSameDiagonal(ByVal ordSqr As Byte) As Boolean
Dim diffOrdinal As Integer

    diffOrdinal = m_ordinal - ordSqr
    If diffOrdinal Mod pawnWhiteAttackRightOffset = 0 Then
        IsSameDiagonal = True
    ElseIf diffOrdinal Mod pawnWhiteAttackLeftOffset = 0 Then
        IsSameDiagonal = True
    Else
        IsSameDiagonal = False
    End If
End Function

Public Function IsAlignedDiagonal45(ByVal ordSqr As Byte) As Boolean
    IsAlignedDiagonal45 = (m_ordinal - ordSqr) Mod pawnWhiteAttackRightOffset = 0
End Function

Public Function IsAlignedDiagonal315(ByVal ordSqr As Byte) As Boolean
    IsAlignedDiagonal315 = (m_ordinal - ordSqr) Mod pawnWhiteAttackLeftOffset = 0
End Function

Public Function AttackerPieceList(playerThis As Player) As Collection
Dim pieceThis As Piece, pieceFullList As Collection, pieceAttackerList As Collection

    Set pieceAttackerList = New Collection
    Set pieceFullList = playerThis.ListPiece
    For Each pieceThis In pieceFullList
        If pieceThis.IsAttacking(m_ordinal) Then
            pieceAttackerList.Add pieceThis
        End If
    Next
    Set AttackerPieceList = pieceAttackerList
End Function

